<form class="test-provider-form" name="testProviderForm">
    <div class="test-provider-form__header">
        <div class="test-provider-form__integration-name">
            <md-input-container ng-if="!$ctrl.simpleForm && $ctrl.hasNameField">
                <label name="integrationNameLabel" for="integrationName">Name</label>
                <input id="integrationName"
                    name="integrationName"
                    placeholder="Enter integration name"
                    type="text"
                    ng-readonly="$ctrl.isReadOnlyForm"
                    ng-minlength="::$ctrl.getValidationValue('textField', 'minlength')"
                    ng-maxlength="::$ctrl.getValidationValue('textField', 'maxlength')"
                    ng-disabled="$ctrl.isSaving"
                    required
                    ng-model="$ctrl.integration.name"/>
                <div ng-messages="testProviderForm.integrationName.$error"
                    ng-if="testProviderForm.integrationName.$dirty || testProviderForm.integrationName.$touched">
                    <div ng-repeat="validation in $ctrl.validations.textField"
                        ng-message-exp="validation.name">
                    <span>
                        <md-tooltip ng-if="!$ctrl.isTouchDevice && validation.additional"
                            md-autohide
                            md-delay="300"
                            md-direction="top">{{ validation.additional }}</md-tooltip>
                        {{ validation.message }}
                    </span>
                    </div>
                </div>
            </md-input-container>
        </div>
        <div class="test-provider-form__integration-actions">
            <md-button name="enableIntegration"
                title="{{ $ctrl.integration.enabled ? 'Disable' : 'Enable' }} integration"
                aria-label="Enable/disable integration"
                class="md-icon-button zf-icon-button"
                ng-class="{ _enabled: $ctrl.integration.enabled }"
                ng-disabled="!$ctrl.integrationSource || $ctrl.isSaving"
                ng-click="$ctrl.switchIntegrationState()">
                <md-icon>power_settings_new</md-icon>
            </md-button>
            <md-button name="deleteIntegration"
                ng-if="!$ctrl.isReadOnlyForm && !$ctrl.isUnableDelete"
                title="Delete integration"
                aria-label="Delete integration"
                class="md-icon-button zf-icon-button"
                ng-disabled="!$ctrl.integrationSource || $ctrl.isSaving"
                ng-click="$ctrl.deleteIntegration(testProviderForm)">
                <md-icon>delete_outline</md-icon>
            </md-button>
        </div>
    </div>
    <div class="test-provider-form__body">
        <md-input-container class="text-input">
            <label name="integrationHubUrlLabel"
                for="integrationHubUrl">
                {{::$ctrl.getFieldLabel('hubUrl')}}
            </label>
            <input id="integrationHubUrl"
                name="integrationHubUrl"
                type="url"
                ng-minlength="::$ctrl.getValidationValue('hubUrl', 'minlength')"
                ng-maxlength="::$ctrl.getValidationValue('hubUrl', 'maxlength')"
                ng-pattern="::$ctrl.getValidationValue('hubUrl', 'pattern')"
                ng-trim="false"
                ng-disabled="$ctrl.isSaving"
                required
                ng-readonly="$ctrl.isReadOnlyForm"
                ng-class="{ '_with-copy-btn': $ctrl.displayCopyButtons }"
                ng-model-options="{ debounce: 500 }"
                ng-model="$ctrl.integration.hubUrl"/>
            <div ng-messages="testProviderForm.integrationHubUrl.$error"
                ng-if="testProviderForm.integrationHubUrl.$dirty || testProviderForm.integrationHubUrl.$touched">
                <div ng-repeat="validation in $ctrl.validations.hubUrl"
                    ng-message-exp="validation.name">
                    <span>
                        <md-tooltip ng-if="!$ctrl.isTouchDevice && validation.additional"
                            md-autohide
                            md-delay="300"
                            md-direction="top">{{ validation.additional }}</md-tooltip>
                        {{ validation.message }}
                    </span>
                </div>
            </div>
            <md-button ng-click="$ctrl.copyToClipboard($ctrl.integration.hubUrl)"
                ng-if="$ctrl.displayCopyButtons"
                ng-disabled="!$ctrl.integration.hubUrl || $ctrl.isSaving"
                class="md-icon-button">
                <md-icon class="material-icons"
                    role="img"
                    aria-label="copy">content_copy</md-icon>
            </md-button>
        </md-input-container>
        <md-input-container ng-if="!$ctrl.simpleForm">
            <label name="integrationUsernameLabel"
                for="integrationUsername">
                {{::$ctrl.getFieldLabel('username')}}
            </label>
            <input id="integrationUsername"
                name="integrationUsername"
                type="text"
                ng-minlength="::$ctrl.getValidationValue('textField', 'minlength')"
                ng-maxlength="::$ctrl.getValidationValue('textField', 'maxlength')"
                ng-pattern="::$ctrl.getValidationValue('textField', 'pattern')"
                ng-trim="false"
                ng-disabled="$ctrl.isSaving"
                required
                ng-readonly="$ctrl.isReadOnlyForm"
                ng-class="{ '_with-copy-btn': $ctrl.displayCopyButtons }"
                ng-model-options="{ debounce: 500 }"
                ng-model="$ctrl.integration.username"/>
            <div ng-messages="testProviderForm.integrationUsername.$error"
                ng-if="testProviderForm.integrationUsername.$dirty || testProviderForm.integrationUsername.$touched">
                <div ng-repeat="validation in $ctrl.validations.textField"
                    ng-message-exp="validation.name">
                    <span>
                        <md-tooltip ng-if="!$ctrl.isTouchDevice && validation.additional"
                            md-autohide
                            md-delay="300"
                            md-direction="top">{{ validation.additional }}</md-tooltip>
                        {{ validation.message }}
                    </span>
                </div>
            </div>
            <md-button ng-click="$ctrl.copyToClipboard($ctrl.integration.username)"
                ng-if="$ctrl.displayCopyButtons"
                ng-disabled="!$ctrl.integration.username || $ctrl.isSaving"
                class="md-icon-button">
                <md-icon class="material-icons"
                    role="img"
                    aria-label="copy">content_copy</md-icon>
        </md-input-container>
        <md-input-container ng-if="!$ctrl.simpleForm">
            <label name="integrationAccessKeyLabel"
                for="integrationAccessKey">
                {{::$ctrl.getFieldLabel('accessKey')}}
            </label>
            <input id="integrationAccessKey"
                name="integrationAccessKey"
                type="{{ $ctrl.displayToken ? 'test' : 'password'}}"
                ng-minlength="::$ctrl.getValidationValue('textField', 'minlength')"
                ng-maxlength="::$ctrl.getValidationValue('textField', 'maxlength')"
                ng-pattern="::$ctrl.getValidationValue('textField', 'pattern')"
                ng-disabled="$ctrl.isSaving"
                ng-change="$ctrl.onPassChange(testProviderForm.integrationAccessKey)"
                required
                ng-readonly="$ctrl.isReadOnlyForm"
                ng-class="{ '_with-copy-btn': $ctrl.displayCopyButtons }"
                ng-model-options="{ debounce: 500 }"
                ng-model="$ctrl.integration.accessKey"/>
            <div ng-messages="testProviderForm.integrationAccessKey.$error"
                ng-if="testProviderForm.integrationAccessKey.$dirty || testProviderForm.integrationAccessKey.$touched">
                <div ng-repeat="validation in $ctrl.validations.textField"
                    ng-message-exp="validation.name">
                    <span>
                        <md-tooltip ng-if="!$ctrl.isTouchDevice && validation.additional"
                            md-autohide
                            md-delay="300"
                            md-direction="top">{{ validation.additional }}</md-tooltip>
                        {{ validation.message }}
                    </span>
                </div>
            </div>
            <md-button ng-click="$ctrl.copyToClipboard($ctrl.integration.accessKey)"
                ng-if="$ctrl.displayCopyButtons"
                ng-disabled="!$ctrl.integration.accessKey || $ctrl.isSaving"
                class="md-icon-button">
                <md-icon class="material-icons"
                    role="img"
                    aria-label="copy">content_copy</md-icon>
        </md-input-container>
    </div>
    <div class="test-provider-form__footer">
        <div class="test-provider-form__footer-actions">
            <md-button class="md-raised btn-w-xs _left-icon _test-integration"
                ng-click="$ctrl.testIntegration()"
                ng-disabled="testProviderForm.$invalid || $ctrl.isSaving">
                <md-icon class="material-icons">power_outline</md-icon>
                <span class="md-button__text">Test</span>
            </md-button>
            <ng-transclude></ng-transclude>
            <md-button class="md-raised btn-w-xs"
                ng-if="!$ctrl.isReadOnlyForm"
                ng-click="$ctrl.cancel(testProviderForm)"
                ng-disabled="testProviderForm.$pristine  || $ctrl.isSaving">Cancel</md-button>
            <md-button class="md-raised btn-w-xs md-primary"
                ng-if="!$ctrl.isReadOnlyForm"
                ng-click="$ctrl.saveIntegration(testProviderForm)"
                ng-disabled="testProviderForm.$pristine || testProviderForm.$invalid || $ctrl.isSaving">Save</md-button>
        </div>
        <div class="test-provider-form__footer-messages">
            <!--TODO: [-] refactor messages-->
            <div class="test-provider-form__footer-message _connecting no-animate"
                ng-if="$ctrl.testingStatus === 'loading'">
                <md-progress-circular class="test-provider-form__footer-message-icon"
                    md-mode="indeterminate"
                    md-diameter="16"></md-progress-circular>
                <div class="test-provider-form__footer-message-text">Connection</div>
            </div>
            <div class="test-provider-form__footer-message _connected no-animate"
                ng-if="$ctrl.testingStatus === 'success'">
                <md-icon class="test-provider-form__footer-message-icon material-icons">done</md-icon>
                <div class="test-provider-form__footer-message-text">Integration is connected.</div>
            </div>
            <div class="test-provider-form__footer-message _failed no-animate"
                ng-if="$ctrl.testingStatus === 'fail'">
                <md-icon class="test-provider-form__footer-message-icon material-icons">warning_amber</md-icon>
                <div class="test-provider-form__footer-message-text">
                    <div>Connection failed.</div>
                    <div ng-repeat="messageLine in $ctrl.testingStatusMessages">{{messageLine}}</div>
                </div>
            </div>
            <div class="test-provider-form__footer-message _failed no-animate"
                ng-if="$ctrl.testingStatus === 'error'">
                <md-icon class="test-provider-form__footer-message-icon material-icons">warning_amber</md-icon>
                <div class="test-provider-form__footer-message-text">
                    <div>Unable to check connection.</div>
                    <div ng-repeat="messageLine in $ctrl.testingStatusMessages">{{messageLine}}</div>
                </div>
            </div>
        </div>
    </div>
</form>
